function [ foldedInvCov, foldedStatistic, params, foldParams ] = ...
    combineFSIDMatFiles (outFile, varargin)
%
% Routine to combine FSID .mat files (possibly generated by parallel processes).
% Combined output can be written in both .mat and .gwf formats
%
%
% [ foldedInvCov, foldedStatistic, params, foldParams ] = ...
%   combineFSIDMatFiles (outFile, inFiles...)
%
% outFile          : (OPTIONAL) String. Output .mat file
% varargin         : Strings. List of FSID .mat files to combine.
%                    Each file is one argument
%
% foldedInvCov     : Real matrix (t,f). Inverse covariance of folded statistic
% foldedStatistic  : Complex matrix (t,f). Folded statistic
% params           : Structure. Parameters read from the first frame
% foldParams       : Structure. Parameters used for folding
%

%
% Author: Sanjit Mitra <sanjit.mitra@ligo.org>
%


%% Check arguments
if (nargin < 2)
  error(['Not enough arguments. For usage info: help ' mfilename]);
end


%===== Read the first file first and set the parameters and variables ======%

fprintf('\nReading first input file: %s',varargin{1});
load(varargin{1});
fprintf('\tDONE\n');


if ~isempty(strtrim(outFile))
  fprintf('Final FSID will be written to %s\n',outFile);
end


if isfield(foldParams,'FSIDFramePrefix')
  fprintf('FSID will be written to frames %s...\n',foldParams.FSIDFramePrefix);
  fprintf('with version number: %d\n',foldParams.version);
  fprintf('Each frame will have max %d segments\n',foldParams.segmentsPerFrame);
  fprintf('GPS time (sidereal) of frames will be increased by: ~%dsec\n',...
        foldParams.FSIDGPSOffset);
  fprintf('GPS time will be further offset by: ~%dsec\n',...
        foldParams.startOffset);
end


if isfield(foldParams,'FSIDJobFile')
  fprintf('FSID job file will be written as: %s\n',foldParams.FSIDJobFile);
end


if isfield(foldParams,'explicit4isotropic') & (foldParams.explicit4isotropic==1)
  fprintf('Explicit isotropic search channels will be added\n');
end

% Some more accounting
totSegDist = foldParams.segDist;
sumStartOffset = foldParams.startOffset * sum(totSegDist);



%================== Read and combine FSID from .mat files ==================%

nFile = size(varargin,2);

if nFile > 1
  fprintf('Reading and combining FSID from .mat files: ');
  for iFile = 2:nFile
    fprintf('\n\tProcessing %s',varargin{iFile});
    part = load(varargin{iFile});

    totSegDist = totSegDist + part.foldParams.segDist;
    sumStartOffset = sumStartOffset + ...
      part.foldParams.startOffset * sum(part.foldParams.segDist);

    foldedInvCov.Diag = foldedInvCov.Diag + part.foldedInvCov.Diag;
    foldedInvCov.Prev = foldedInvCov.Prev + part.foldedInvCov.Prev;
    foldedInvCov.Next = foldedInvCov.Next + part.foldedInvCov.Next;

    foldedStatistic = foldedStatistic + part.foldedStatistic;
  end
  fprintf('\nDONE\n');
end

params.GPSEnd = part.params.GPSEnd;


foldParams.segDist = totSegDist;
foldParams.startOffset = sumStartOffset / sum(totSegDist);



%======================= Write folded data to frames =======================%

try
  fprintf('Writing folded SID frame files: ',foldParams.FSIDFramePrefix);
  writeFSID (foldParams, params, foldedInvCov, foldedStatistic);
  fprintf('DONE\n');
catch
  fprintf('FSID frames not written.\n');
end



%======================== Write FSID to a .mat file ========================%

if ~isempty(strtrim(outFile))
  fprintf('Writing folded SID to .mat file...');
  save (strtrim(outFile), 'firstSeg', 'lastSeg', ...
      'foldParams','params', 'foldedInvCov', 'foldedStatistic');
  fprintf('DONE\n');
end


return
